<?php
    if ( isset( $_GET['delete'] ) )
    {
        $removeid=$_GET['delete'];

        global $afflctable;
        $results=$afflctable->DeleteLinkByID($removeid);
        $results=$afflctable->DeleteDailyStatisticsByID($removeid);
        $results=$afflctable->DeleteTracksByID($removeid);
    } 

    if ( isset( $_GET['reset'] ) )
    {
        $resetid=$_GET['reset'];

        global $afflctable;
        $results=$afflctable->DeleteDailyStatisticsByID($resetid);
        $results=$afflctable->DeleteTracksByID($resetid);
    } 
?>


<?php
    function VertifyPerLink()
    {
        $perlink = get_option( 'permalink_structure' );
        if ( $perlink == "" )
        {
           echo ('<div id="message" class="error"><p>You must set the "Permalinks" first to use affiliate link cloaking. Make sure it is not "Default". <a href="/wp-admin/options-permalink.php">Here is Permalink Settings</a></p></div>');
        }
    }

    function afflc_GetMessage()
    { 
        global $wpdb;
        $lastgetvar = $wpdb->prefix."afflc_lasttime";
        $lastmsgvar = $wpdb->prefix."afflc_lastmsg";
        $lastgettime = get_option( $lastgetvar ); 
        $lastgetmsg = get_option( $lastmsgvar ); 

        if ( time() - $lastgettime < 7200 ) 
        {
             if ( $lastgetmsg != "" )
             {
                 echo ( $lastgetmsg );
             }
             return;
        }
        
        $lastgettime = time();

        $checkmsg = new WP_Http;
        $msghtml = $checkmsg->request( 'http://clionpid.com/clionpidmessage' ,array( 'timeout' => 3 ));
        if ( is_wp_error( $msghtml ) ) return;

        $msgdoc = new DOMDocument();
        $msgdoc ->loadHTML ( $msghtml['body'] );                   
        $msgtags = $msgdoc ->getElementById("clionpidmsg");
        if ( NULL == $msgtags ) 
        {
           $lastgetmsg = "";
           update_option( $lastgetvar, $lastgettime );
           update_option( $lastmsgvar, $lastgetmsg );
           return;
        }

        $lastgetmsg = $msgdoc -> saveHTML();
        echo ( $lastgetmsg );

        update_option( $lastgetvar, $lastgettime );
        update_option( $lastmsgvar, $lastgetmsg );
    }

    function ShowAllLink()
    {
        global $afflctable;
        $results=$afflctable->GetAllLinks();
        
        foreach( $results as $rowdata)
        { 
            $monthlystatus=$afflctable->GetDailyStatisticsByMonth( time(), $rowdata->id );
            $monthhits=0;
            $monthuniquevisitors=0;
            $todayhits=0;
            $todayuniquevisitors=0;
            foreach ( $monthlystatus as $onedaystatus)
            {
                $monthhits = $monthhits + $onedaystatus->hits;
                $monthuniquevisitors = $monthuniquevisitors + $onedaystatus->uniquevisitors;
                if ( $onedaystatus->sday == date('d',time()) )
                {
                   $todayhits = $onedaystatus->hits;
                   $todayuniquevisitors = $onedaystatus->uniquevisitors;
                }
            }
            /////////////////////////////////////////////////
            echo('<tr>');

            echo '<td><a class="row-title" href="'.admin_url('admin.php?page=affiliate-link-cloaking/ui_addnewlink.php&edit=').$rowdata->id.'">';
            echo $rowdata->linktitle.'</a>';
            echo '<div class="row-actions">
				<span class="edit">
					<a href="'.admin_url('admin.php?page=affiliate-link-cloaking/ui_addnewlink.php&edit=').$rowdata->id.'" title="Edit this link">Edit</a>
				</span>
                                |<span class="delete">
					<a name="afflctdeletelink" href="'.admin_url('admin.php?page=affiliate-link-cloaking/affiliatelinkcloaking.php&delete=').$rowdata->id.'" title="Delete this link">Delete</a>
				</span>
                                |<span class="reset">
					<a name="afflctresetlink" href="'.admin_url('admin.php?page=affiliate-link-cloaking/affiliatelinkcloaking.php&reset=').$rowdata->id.'" title="Reset the status of this link">Reset</a>
				</span>
			</div>';
            echo '</td>';
        
            $shortlink=get_bloginfo('url').'/'.$rowdata->cloaklink;
            echo '<td class="column-url"><a href="'.$shortlink.'">'.$shortlink.'</td>';
            echo '<td class="column-url"><a href="'.$rowdata->afflink.'">'.$rowdata->afflink.'</td>';
            echo '<td class="column-url" style="text-align:center"><a href="'.admin_url('admin.php?page=affiliate-link-cloaking/ui_track.php&action=gettrack&linkid='). $rowdata->id. '">'.$todayhits.'/'.$monthhits. '</a></td>';
            echo '<td class="column-url" style="text-align:center"><a href="'.admin_url('admin.php?page=affiliate-link-cloaking/ui_track.php&action=gettrack&linkid='). $rowdata->id. '">'.$todayuniquevisitors.'/'.$monthuniquevisitors. '</a></td>';
            echo '<td>'.$rowdata->createdate .'</td>';
            echo('</tr>');
        }
       
    }
   
?>


<div class="wrap">
    <h2><img src="<?php echo (get_bloginfo('url').'/wp-content/plugins/affiliate-link-cloaking/img/AffIcon_32.png'); ?>"  / > Affiliate link cloaking <a href="<?php echo (admin_url('admin.php?page=affiliate-link-cloaking/ui_addnewlink.php')); ?>" class="button add-new-h2">Add New Link</a> <a href="<?php echo (admin_url('admin.php?page=affiliate-link-cloaking/ui_track.php')); ?>" class="button add-new-h2">View Status</a> <a href="<?php echo ('http://www.clionpid.com/support/'); ?>" class="button add-new-h2">Get Help And Report Bugs</a> </h2>
</div>
<p></p>
<?php afflc_GetMessage(); ?>
<?php VertifyPerLink(); ?>
<table class="widefat" cellspacing="0" id="affviewalltable">
    <thead>
        <tr>
            <th scope="col" id="headlinktitle">Link Title</a></th>
	    <th scope="col" id="headcloakinglink">Short Link</th>
	    <th scope="col" id="headafflink">Affiliate Link</th>
	    <th scope="col" id="headhits" style="text-align:center">Hits<div style="font-weight:normal">(Today/Month)</div></th>
            <th scope="col" id="headuniquev" style="text-align:center">Unique Visitors<div style="font-weight:normal">(Today/Month)</div></th>
            <th scope="col" id="headdate" >Create Date</th>
	</tr>
    <thead>
    
    <tfoot>
        <tr>
	    <th scope="col" id="footlinkname">Link Name</th>
	    <th scope="col" id="footcloakinglink">Short Link</th>
	    <th scope="col" id="footafflink">Affiliate Link</th>
	    <th scope="col" id="foothits" style="text-align:center">Hits<div style="font-weight:normal">(Today/Month)</div></th>
            <th scope="col" id="footuniquev" style="text-align:center">Unique Visitors<div style="font-weight:normal">(Today/Month)</div></th>
            <th scope="col" id="footdate">Create Date</th>
        </tr>
    </tfoot>
    
    <tbody>
        <?php ShowAllLink(); ?>
    </tbody>
    
    <script type="text/javascript"> 
        var deletelist=document.getElementsByName('afflctdeletelink');
        for (var i=0; i<deletelist.length; i++)
        {
            deletelist[i].onclick=function(){ return confirm("Do you want to delete the link ? It will also delete the status of this link ! "); };
        }

        var resetlist=document.getElementsByName('afflctresetlink');
        for (var i=0; i<resetlist.length; i++)
        {
            resetlist[i].onclick=function(){ return confirm("Do you want to reset the status of this link ? "); };
        }

    </script>
</table>
